;----------------------------------------------------------------------------

;SG-633 header file

;----------------------------- Constantes: ----------------------------------

.equ	F_CLK	= 8000000	;Fclk, Hz

;------------------------- Derivated Constantes: ----------------------------


.equ MAXBYTE = 0xFF
.equ MAXWORD = 0xFFFF

;-------------------------- Ports Definitions: ------------------------------

;Port B:

.equ	DIRB	= 0b11111111	;Port B direction
.equ	PUPB	= 0b00000000	;Port B pull-ups

.equ	SIN_B	= PB0		;SIN B PWM (PSCOUT20)
.equ	AMP_B	= PB1		;AMP B PWM (PSCOUT21)
.equ	SIN_A	= PB6		;SIN A PWM (PSCOUT11)
.equ	AMP_A	= PB7		;AMP A PWM (PSCOUT01)

;Port C:

.equ	DIRC	= 0b11111101	;Port C direction
.equ	PUPC	= 0b00000010	;Port C pull-ups

.equ	AMP_C	= PC0		;AMP C PWM (PSCOUT10)
.equ	MAINS	= PC1		;Mains sync
.equ	CINT	= PC2		;Co-processor INT

.macro	Port_CINT_0		;CINT = 0
	cbi	PORTC,CINT
.endm

.macro	Port_CINT_1		;CINT = 1
	sbi	PORTC,CINT
.endm

.macro	Port_CINT_CPL		;CINT = !CINT
	sbi	PINC,CINT
.endm

;Port D:

.equ	DIRD	= 0b11101111	;Port D direction
.equ	PUPD	= 0b00011000	;Port D pull-ups

.equ	SIN_C	= PD0		;SIN C PWM (PSCOUT00)
.equ	CTXD	= PD3		;Co-processor TXD
.equ	CRXD	= PD4		;Co-processor RXD

;Port E:

.equ	DIRE	= 0b11111111	;Port E direction
.equ	PUPE	= 0b00000000	;Port E pull-ups

;------------------------- Global Register Variables: -----------------------

;* - used in DDS interrupt
;r0, r1 * used with mul instruction

.def	tsreg	= r2		;* SREG store

.def	APhaseL	= r3		;* A phase code
.def	APhaseM	= r4		;*
.def	APhaseN	= r5		;*
.def	APhaseP	= r6		;*

.def	BPhaseL	= r7		;* B phase code
.def	BPhaseM	= r8		;*
.def	BPhaseN	= r9		;*
.def	BPhaseP	= r10		;*

.def	CPhaseL	= r11		;* C phase code
.def	CPhaseM	= r12		;*
.def	CPhaseN	= r13		;*
.def	CPhaseP	= r14		;*

.def	SinL	= r16		;* amplitude code
.def	SinH	= r17		;*

.def	zero	= r18		;* register with zero value

.def	temp	= r19		;temporary register temp
.def	cnt	= r20		;temporary register Cnt

;r26,r27 used as X-register
;r28,r29 used as Y-register
;r30,r31 * used as Z-register

;----------------------------------------------------------------------------
