//----------------------------------------------------------------------------

//Sine wave generator SG-642
//   

//----------------------------------------------------------------------------

#include "Main.h"
#include "Commands.h"
#include "Port.h"
#include "Wake.h"
#include "Menu.h"
#include "Sound.h"
#include "Lcd133x64.h"

//------------------------------ : ----------------------------------

const __flash char Info[] = {"SG-633 V"VER}; // 

//---------------------------  : -----------------------------

void Tx_Replay(char n, char err); //   

//----------------------    : -------------------------

void Tx_Replay(char n, char err)
{
  Tx_Nbt = n;                     // 
  Tx_Dat[0] = err;                // 
  Tx_Cmd = Command;               //
  Port_Tx();                      // 
  Command = CMD_NOP;              // 
}

//----------------------------  : ----------------------------

void Commands_Exe(void)
{
  char i;
  switch(Command)
  {
  case CMD_ERR: // 
    {
      Tx_Replay(1, ERR_TX);
      break;
    }
  case CMD_ECHO: // ""
    {
      for(i = 0; i < Rx_Nbt && i < FRAME; i++)
        Tx_Dat[i] = Rx_Dat[i];
      Tx_Replay(Rx_Nbt, Tx_Dat[0]);
      break;
    }
  case CMD_INFO: // ""
    {
      char ch = 1;
      for(i = 0; i < FRAME && ch; i++)
        ch = Tx_Dat[i] = Info[i];
      Tx_Replay(i, Tx_Dat[0]);
      break;
    }
  case CMD_SETMODE: //  
    {
      Menu_SetLock(Rx_Dat[0]);
      Tx_Replay(1, ERR_NO);
      break;
    }
  case CMD_GETMODE: //  
    {
      Tx_Dat[1] = Menu_GetLock();
      Tx_Replay(2, ERR_NO);
      break;
    }
  case CMD_SETPAR: // 
    {
      char ch = Rx_Dat[0];         // 
      char par = Rx_Dat[1];        // 
      long v = DWORD(Rx_Dat[5], Rx_Dat[4], Rx_Dat[3], Rx_Dat[2]);
      Menu_SetPar(ch, par, v);     // 
      Tx_Replay(1, ERR_NO);
      break;
    }
  case CMD_GETPAR: // 
    {
      long v = Menu_GetPar(Rx_Dat[0], Rx_Dat[1]);
      Tx_Dat[1] = BYTE1(v);
      Tx_Dat[2] = BYTE2(v);
      Tx_Dat[3] = BYTE3(v);
      Tx_Dat[4] = BYTE4(v);
      Tx_Replay(5, ERR_NO);
      break;
    }
  case CMD_GETSELPAR: //  
    {
      char ch = Menu_GetSelChan(); // 
      char par = Menu_GetSelPar(); // 
      long v = Menu_GetPar(ch, par);
      Tx_Dat[1] = ch;
      Tx_Dat[2] = par;
      Tx_Dat[3] = BYTE1(v);
      Tx_Dat[4] = BYTE2(v);
      Tx_Dat[5] = BYTE3(v);
      Tx_Dat[6] = BYTE4(v);
      Tx_Replay(7, ERR_NO);
      break;
    }
  }
}

//----------------------------------------------------------------------------
