//----------------------------------------------------------------------------

//Sine wave generator SG-642
//  

//----------------------------------------------------------------------------

#include "Main.h"
#include "Keyboard.h"

//--------------------------- : -------------------------------------

#define DB_TM      50 //  , ms
#define NOREP_TM  800 //  , ms
#define REP_TM    200 // , ms

//---------------------------- : -----------------------------------

static char KeyCode;

//--------------------------  : ------------------------------

char Scan(void); // 

//-----------------------  : ---------------------------

char Scan(void)
{
  char s = 0, d;

  if(!Pin_KEY_S) s |= 0x01;
  if(!Pin_KEY_D) s |= 0x02;
  if(!Pin_KEY_U) s |= 0x04;
  if(!Pin_KEY_C) s |= 0x08;
  if(!Pin_KEY_E) s |= 0x10;

  switch(s) //    :
  {
  case 0x01: d = KEY_STEP; break; // STEP
  case 0x02: d = KEY_DN;   break; // DN
  case 0x04: d = KEY_UP;   break; // UP
  case 0x08: d = KEY_CHAN; break; // CHAN
  case 0x10: d = KEY_ESB;  break; // 
  default :  d = KEY_NO;
  }
  return(d);
}

//------------------------  : -------------------------

void Keyboard_Init(void)
{
  KeyCode = KEY_NO;
}

//-------------------------  : ----------------------------

void Keyboard_Exe(bool t)
{
  static char LastCode = KEY_NO;
  static char TempCode = KEY_NO;
  static char DbncTimer = 0;
  static int RepTimer = 0;

  if(t)
  {
    if(DbncTimer) DbncTimer--;
    if(RepTimer) RepTimer--;
    char k = Scan();
    if(k != LastCode) // 
    {
      if(k != TempCode) //
      {
        TempCode = k;
        DbncTimer = ms2sys(DB_TM);
      }
      else
      {
        if(!DbncTimer)
        {
          if(k != KEY_NO) // 
          {
            RepTimer = ms2sys(NOREP_TM);
            KeyCode = k;
          }
          else // 
          {
            if(!(LastCode & REP))
              KeyCode = LastCode | REL;
          }
          LastCode = k;
        }
      }
    }
    else // 
    {
      if(RepTimer == 1)
      {
        if(k == KEY_UP || k == KEY_DN)
        {
          KeyCode = k | REP;
          RepTimer = ms2sys(REP_TM);
        }
        if(k == KEY_ESB)
          KeyCode = k | REP;
      }
    }
  }
}

//------------------------   : ----------------------------

void Keyboard_SetCode(char code)
{
  KeyCode = code;
}

//--------------------------   : -----------------------------

char Keyboard_GetCode(void)
{
  return(KeyCode);
}

//----------------------------------------------------------------------------
