//----------------------------------------------------------------------------

//   

//  SND      .
//     2.

//----------------------------------------------------------------------------

#include "Main.h"
#include "Sound.h"

//----------------------------  : -----------------------------

#define ACT_SND_LOW  //  

//------------------------------- : ---------------------------------

#define BeepD 100.0  //  , 
#define BeepF 1.000  //  , 

#define HighD 100.0  //  , 
#define HighF 1.400  //  , 

#define TickD 40.0   //  , 
#define TickF 1.000  //  , 

#define NoteD 20.0   //  , 
#define NoteF 0.400  //  , 

#define BellD 200.0  //  , 
#define BellF 0.400  //  , 

//----------------------------------------------------------------------------

//  [KHz]    [ ]:
#define KHZ2T(x) (int)((F_CLK * 1000.0 / 512.0) / (x))
//  [mS]   :
#define MS2P(x, y) (int)((x) * (y))

//----------------------------------------------------------------------------

static char SndD;   //    
static bool Enable; // 

//----------------------------------------------------------------------------

void Sound(char d, char t); // 
#pragma vector = TIMER2_COMPA_vect
__interrupt void GenSnd(void); //    

//---------------    : ------------------

void Sound_Init(void)
{
  SndD = 0;
  TCCR2A = (1 << WGM21); //CTC
  TCCR2B = (1 << CS22) | (1 << CS21); //CK/256
  Enable = 1;
}

//--------------------- / : -------------------------

void Sound_En(bool p)
{
  Enable = p;
}

//-----------------    : --------------------

bool Sound_Mute(void)
{
  return(!Enable);
}

//---------------  :  d,  t: -----------------

void Sound(char d, char t)
{
  if(Enable)
  {
    OCR2A = t;
    SndD = d;
    TIFR2 = (1 << OCF2A);    //Clear pending interrupts
    TIMSK2 |= (1 << OCIE2A); //Timer 2 interrupt enable
  }
}

//-----------------     : ------------------

#pragma vector = TIMER2_COMPA_vect
__interrupt void GenSnd(void)
{
  Port_SND? Port_SND_0 : Port_SND_1;
  if(SndD) SndD--;
    else
#ifdef ACT_SND_LOW
      if(Port_SND) TIMSK2 &= ~(1 << OCIE2A);
#else    
      if(!Port_SND) TIMSK2 &= ~(1 << OCIE2A);
#endif    
}

//------------     (beep): --------------

__monitor void Sound_Beep(void)
{
  Sound(MS2P(BeepD, BeepF), KHZ2T(BeepF));
}

//------------     (high beep): -------------

__monitor void Sound_High(void)
{
  Sound(MS2P(HighD, HighF), KHZ2T(HighF));
}

//-------------     (tick): ----------------

__monitor void Sound_Tick(void)
{
  Sound(MS2P(TickD, TickF), KHZ2T(TickF));
}

//------------     (note): ---------------

__monitor void Sound_Note(void)
{
  Sound(MS2P(NoteD, NoteF), KHZ2T(NoteF));
}

//-----------     (error bell): ---------------

__monitor void Sound_Bell(void)
{
  Sound(MS2P(BellD, BellF), KHZ2T(BellF));
}

//----------------------------------------------------------------------------
